'use strict';
var NodeUtil = require('util');
var debug = require("debug")('rebox-log');
var util = require('./util');
var options = {};


function log(appOptions) {
  options = appOptions;
}

log.prototype.info = function*(text, username, category) {
  var data = {
    txt: text,
    user: username,
    cat: category,
    level: "info"
  };
  return yield util.ajax(options, data);
}

log.prototype.debug = function*(text, username, category) {
  var data = {
    txt: text,
    cat: category,
    user: username,
    level: "debug"
  };
  return yield util.ajax(options, data);
}


log.prototype.warn = function*(text, username, category) {
  var data = {
    txt: text,
    cat: category,
    user: username,
    level: "warn"
  };
  return yield util.ajax(options, data);
}

log.prototype.error = function*(text, username, category) {
  var data = {
    txt: text,
    user: username,
    cat: category,
    level: "error"
  };
  return yield util.ajax(options, data);
}

module.exports = log;