'use strict';

var co = require('co');
var request = require('co-request');
var debug = require("debug")('shoots-log');

var token = null;
var expiresTime = null;
var util = {};



util.getToken = function*(appOptions) {
  if (!token || Date.now() >= expiresTime) {
    var uri = appOptions.site + '/api/getToken?appid=' + appOptions.id + "&appsecret=" + appOptions.secret;
    debug('get token uri:=', uri);
    var response = yield request({
      method: 'GET',
      uri: uri,
      resolveWithFullResponse: true,
      json: true
    });
    debug('get token response := ' + JSON.stringify(response));
    if (response && response.body && response.body.errcode == 0) {
      token = response.body.access_token;
      expiresTime = response.expiresTime;
    } else {
      debug('get token fail');
    }
  }
  return token;
}


util.ajax = function*(appOptions, data) {
  var token = yield util.getToken(appOptions);
  var uri = appOptions.site + '/api/log?access_token=' + token;
  debug('post data:= ' + JSON.stringify(data));
  var response = yield request({
    method: 'POST',
    uri: uri,
    resolveWithFullResponse: true,
    body: data,
    json: true
  });
  debug('response := ' + JSON.stringify(response));
  return response && response.body && response.body.errcode == 0;
}
module.exports = util;